VERSION 4.00
Begin VB.Form frmMonitor 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Caption"
   ClientHeight    =   4950
   ClientLeft      =   2520
   ClientTop       =   2595
   ClientWidth     =   6960
   Height          =   5355
   Icon            =   "MONITOR.frx":0000
   Left            =   2460
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   330
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   464
   ShowInTaskbar   =   0   'False
   Top             =   2250
   Width           =   7080
   Begin VB.CommandButton cmdAction 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   525
      Index           =   1
      Left            =   5580
      TabIndex        =   2
      Top             =   4290
      Width           =   1245
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "OK"
      Enabled         =   0   'False
      Height          =   525
      Index           =   0
      Left            =   4200
      TabIndex        =   1
      Top             =   4290
      Width           =   1245
   End
   Begin VB.PictureBox picDesktop 
      AutoRedraw      =   -1  'True
      Height          =   4005
      Left            =   120
      ScaleHeight     =   3945
      ScaleMode       =   0  'User
      ScaleWidth      =   6645
      TabIndex        =   0
      Top             =   120
      Width           =   6705
      Begin VB.CommandButton cmdMonitor 
         Caption         =   "Monitor"
         Height          =   795
         Index           =   0
         Left            =   360
         TabIndex        =   4
         Top             =   240
         Width           =   1155
      End
   End
   Begin VB.Label lblPrompt 
      Caption         =   "Prompt"
      Height          =   525
      Left            =   120
      TabIndex        =   3
      Top             =   4290
      Width           =   4005
   End
End
Attribute VB_Name = "frmMonitor"
Attribute VB_Creatable = False
Attribute VB_Exposed = False


Option Explicit

' --------------------------------------------------------------------------
'               Copyright (C) 1998 Microsoft Corporation                   '
' --------------------------------------------------------------------------
' You have a royalty-free right to use, modify, reproduce and distribute   '
' the Sample Application Files (and/or any modified version) in any way    '
' you find useful, provided that you agree that Microsoft has no warranty, '
' obligations or liability for any Sample Application Files.               '
' --------------------------------------------------------------------------
' Written by Mike Dixon (mikedix@microsoft.com)                            '
' --------------------------------------------------------------------------

'===================================================
'frmMonitor - Called only from the clsMonitors Class
'             ShowMonitorDialog method
'===================================================

Const BTN_OK = 0
Const BTN_CANCEL = 1

Const GUI_BORDER = 8

'Private member variables
'================================
Private m_DialogResult As Long
Private m_DesktopWidth As Long
Private m_DesktopHeight As Long
Private m_DesktopLeft As Long
Private m_DesktopTop As Long

Private m_OwnerForm As Form
Private m_MonitorChosen As Long

'Public Properties and methods
'=============================
Public cMonitorClass As clsMonitors

Public Property Let Owner(OwnerForm As Form)
    Set m_OwnerForm = OwnerForm
End Property

Public Property Let DialogCaption(CaptionString As String)
    Me.Caption = CaptionString
End Property

Public Property Get DialogResult() As Long
    DialogResult = m_DialogResult
End Property

Public Property Let Prompt(PromptString As String)
    lblPrompt.Caption = PromptString
End Property

Public Sub ShowDialog()
    ResizeDialog
End Sub

'Private methods
'===============

Private Sub cmdAction_Click(Index As Integer)
    'Command Button Selection
    Select Case Index
        Case BTN_OK
            m_DialogResult = m_MonitorChosen
            Hide
        Case BTN_CANCEL
            m_DialogResult = 0
            Hide
    End Select
End Sub

Private Sub ResizeDialog()
    'Make our Desktop 3/4 then size of the
    'Monitor that it is being displayed on
    Dim lMonitor As Long
    Dim lMonitorWidth As Long
    Dim lMonitorHeight As Long
    Dim cMonitor As clsMonitor
    Dim lReduction As Double

    With cMonitorClass
        m_DesktopHeight = .DesktopHeight
        m_DesktopWidth = .DesktopWidth
        m_DesktopLeft = .DesktopLeft
        m_DesktopTop = .DesktopTop
    End With
    lReduction = 0.25
        
    'Get the dialog is to be displayed in
    lMonitor = cMonitorClass.GetMonitorFromWindow(Me.hwnd, 1)
    'Find the monitors size
    For Each cMonitor In cMonitorClass.Monitors
        With cMonitor
            If .Handle = lMonitor Then
                lMonitorWidth = .Width
                lMonitorHeight = .Height
                Exit For
            End If
        End With
    Next
    
    If lMonitorWidth = 0 Then lMonitorWidth = m_DesktopWidth
    If lMonitorHeight = 0 Then lMonitorHeight = m_DesktopHeight
    With picDesktop
        .Width = lMonitorWidth * lReduction
        If m_DesktopWidth > m_DesktopHeight Then
            .Height = (m_DesktopHeight * ((m_DesktopWidth \ Screen.TwipsPerPixelX) / .Width)) * (lReduction * 2)
        Else
            .Height = (m_DesktopHeight * ((m_DesktopWidth \ Screen.TwipsPerPixelX) / .Width)) * (lReduction * 3)
        End If        
        .ScaleLeft = m_DesktopLeft
        .ScaleTop = m_DesktopTop
        .ScaleHeight = m_DesktopHeight
        .ScaleWidth = m_DesktopWidth
        
        Me.Width = (.Width + (GUI_BORDER * 2) + 4) * Screen.TwipsPerPixelX
        Me.Height = (Me.Height - (Me.ScaleHeight * Screen.TwipsPerPixelY)) + (((GUI_BORDER * 3) + cmdAction(0).Height + .Height) * Screen.TwipsPerPixelY)
        lblPrompt.Top = .Top + .Height + GUI_BORDER
        cmdAction(0).Top = .Top + .Height + GUI_BORDER
        cmdAction(1).Top = .Top + .Height + GUI_BORDER
        cmdAction(1).Left = Me.ScaleWidth - GUI_BORDER - cmdAction(1).Width
        cmdAction(0).Left = cmdAction(1).Left - GUI_BORDER - cmdAction(0).Width
    End With
    'Center the dialog over the owner
    If m_OwnerForm Is Nothing Then
        cMonitorClass.CenterFormOnMonitor Me
    Else
        cMonitorClass.CenterFormOnMonitor Me, m_OwnerForm
    End If
    
    Dim lMonitorButtonCount As Long
    For Each cMonitor In cMonitorClass.Monitors
        With cMonitor
            If lMonitorButtonCount > 0 Then
                Load cmdMonitor(lMonitorButtonCount)
            End If
            cmdMonitor(lMonitorButtonCount).Move .Left, .Top, .Width, .Height
            cmdMonitor(lMonitorButtonCount).Visible = True
            cmdMonitor(lMonitorButtonCount).Caption = "Monitor " & lMonitorButtonCount + 1
            lMonitorButtonCount = lMonitorButtonCount + 1
        End With
    Next
    Show vbModal
    
End Sub

Private Sub cmdMonitor_Click(Index As Integer)
    Dim btn As Control
    cmdAction(BTN_OK).Enabled = True
    For Each btn In picDesktop.Container
        If btn.Name = "cmdMonitor" Then
            Debug.Print btn.Name
            btn.FontBold = (btn.Index = Index)
        End If
    Next
    m_MonitorChosen = Index + 1
    cmdAction(BTN_OK).SetFocus
End Sub

Private Sub Form_Resize()
    lblPrompt.Width = cmdAction(BTN_OK).Left - lblPrompt.Left
End Sub
