VERSION 4.00
Begin VB.Form frmSample 
   Caption         =   "cMonitors Class Test/Sample Application"
   ClientHeight    =   4500
   ClientLeft      =   3735
   ClientTop       =   3735
   ClientWidth     =   6240
   Height          =   5160
   Icon            =   "SAMPLE.frx":0000
   Left            =   3675
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4500
   ScaleWidth      =   6240
   Top             =   3135
   Width           =   6360
   Begin VB.CommandButton cmdChoose 
      Caption         =   "Choose Monitor Dialog"
      Height          =   495
      Left            =   120
      TabIndex        =   15
      Top             =   2520
      Width           =   3135
   End
   Begin VB.CommandButton cmdVirtualSize 
      Caption         =   "Display Virtual Desktop Size"
      Height          =   495
      Left            =   120
      TabIndex        =   14
      Top             =   1920
      Width           =   3135
   End
   Begin VB.ListBox lstMonitors 
      Height          =   1035
      ItemData        =   "SAMPLE.frx":0442
      Left            =   3510
      List            =   "SAMPLE.frx":0449
      TabIndex        =   11
      Top             =   1590
      Width           =   2595
   End
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "Refresh"
      Height          =   495
      Left            =   4920
      TabIndex        =   10
      Top             =   720
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Height          =   1275
      Left            =   120
      TabIndex        =   4
      Top             =   3060
      Width           =   6015
      Begin VB.OptionButton optDefNear 
         Caption         =   "If no monitor at XY, return nearest monitor"
         Height          =   195
         Left            =   2520
         TabIndex        =   18
         Top             =   840
         Width           =   3255
      End
      Begin VB.OptionButton optDefPri 
         Caption         =   "If no monitor at XY, return primary monitor"
         Height          =   195
         Left            =   2520
         TabIndex        =   17
         Top             =   540
         Width           =   3255
      End
      Begin VB.OptionButton optDefNone 
         Caption         =   "Return None if no monitor at XY"
         Height          =   195
         Left            =   2520
         TabIndex        =   16
         Top             =   240
         Value           =   -1  'True
         Width           =   2835
      End
      Begin VB.CommandButton cmdMonFromPoint 
         Caption         =   "Get Monitor from Point"
         Height          =   495
         Left            =   150
         TabIndex        =   7
         Top             =   240
         Width           =   2175
      End
      Begin VB.TextBox txtX 
         Height          =   285
         Left            =   420
         MaxLength       =   5
         TabIndex        =   6
         Text            =   "1"
         Top             =   810
         Width           =   675
      End
      Begin VB.TextBox txtY 
         Height          =   285
         Left            =   1650
         MaxLength       =   5
         TabIndex        =   5
         Text            =   "1"
         Top             =   810
         Width           =   675
      End
      Begin VB.Label Label1 
         Caption         =   "X:"
         Height          =   195
         Left            =   180
         TabIndex        =   9
         Top             =   870
         Width           =   195
      End
      Begin VB.Label Label2 
         Caption         =   "Y:"
         Height          =   195
         Left            =   1410
         TabIndex        =   8
         Top             =   870
         Width           =   195
      End
   End
   Begin VB.CommandButton cmdCenter 
      Caption         =   "Center this Form on the Current Monitor"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   3135
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   4920
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdWhatMon 
      Caption         =   "Where is the Monitor Am I On?"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   3135
   End
   Begin VB.CommandButton cmdMonCount 
      Caption         =   "Display Monitor Count"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   3840
      Picture         =   "SAMPLE.frx":045A
      Top             =   480
      Width           =   480
   End
   Begin VB.Label Label4 
      Caption         =   "(Double-Click for Monitor position)"
      Height          =   255
      Left            =   3510
      TabIndex        =   13
      Top             =   2760
      Width           =   2625
   End
   Begin VB.Label Label3 
      Caption         =   "Monitor Handles:"
      Height          =   255
      Left            =   3510
      TabIndex        =   12
      Top             =   1320
      Width           =   1275
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu miExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuTest 
      Caption         =   "&Test"
      Begin VB.Menu miSubItem1 
         Caption         =   "SubItem1"
      End
      Begin VB.Menu miSubItem2 
         Caption         =   "SubItem2"
      End
   End
End
Attribute VB_Name = "frmSample"
Attribute VB_Creatable = False
Attribute VB_Exposed = False


' --------------------------------------------------------------------------
'               Copyright (C) 1998 Microsoft Corporation                   '
' --------------------------------------------------------------------------
' You have a royalty-free right to use, modify, reproduce and distribute   '
' the Sample Application Files (and/or any modified version) in any way    '
' you find useful, provided that you agree that Microsoft has no warranty, '
' obligations or liability for any Sample Application Files.               '
' --------------------------------------------------------------------------
' Written by Mike Dixon (mikedix@microsoft.com)                            '
' --------------------------------------------------------------------------
Option Explicit

'Monitors class, contains a collection of monitors
'and functions for multiple monitors
Dim cMonitors As clsMonitors

'Monitor class, contains information about a monitor
Dim cMonitor As clsMonitor


'Rectangle structure, for determining
'monitors at a given position
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'Constants for the return value when finding a monitor
Const MONITOR_DEFAULTTONULL = &H0       'If the monitor is not found, return 0
Const MONITOR_DEFAULTTOPRIMARY = &H1    'If the monitor is not found, return the primary monitor
Const MONITOR_DEFAULTTONEAREST = &H2    'If the monitor is not found, return the nearest monitor

Private Sub Form_Load()
    'Setup the classes
    Set cMonitor = New clsMonitor
    Set cMonitors = New clsMonitors
    'Refresh the monitors listbox
    RefreshMonitors
    
    'Center the form
    cMonitors.CenterFormOnMonitor Me
End Sub

Private Sub miExit_Click()
    Unload Me
End Sub

Private Sub miSubItem1_Click()
    MsgBox "Just a sample menu.", vbInformation
End Sub

Private Sub miSubItem2_Click()
    MsgBox "Just a sample menu.", vbInformation
End Sub

Private Sub cmdChoose_Click()
    '=============================================
    'Prompts the user with a Choose monitor dialog
    'then centers the form on that monitor
    '=============================================
    Dim lMonitorChosen As Long
    
    lMonitorChosen = cMonitors.ShowMonitorDialog("Choose a monitor", "Virtual Desktop", Me)
    
    If lMonitorChosen Then
        'Center the form in the selected monitor
        With cMonitors.Monitors(lMonitorChosen)
            Me.Move .Left * Screen.TwipsPerPixelX + ((.Width * Screen.TwipsPerPixelX) - Me.Width) \ 2, _
            .Top * Screen.TwipsPerPixelY + ((.Height * Screen.TwipsPerPixelY) - Me.Height) \ 2
        End With
    Else
        'User Pressed Cancel
    End If
End Sub

Private Sub cmdCenter_Click()
    '=============================================
    'Center the form on the monitor the form is on
    '=============================================
    cMonitors.CenterFormOnMonitor Me, Me
End Sub

Private Sub cmdExit_Click()
    '=============
    'Exit the Demo
    '=============
    Unload Me
End Sub

Private Sub cmdMonCount_Click()
    '=====================================
    'Display a message box with the number
    'of monitors in use by the system
    '=====================================
    Dim lReturn As Long
    
    lReturn = cMonitors.Monitors.Count
    'Windows 95 and Windows NT 4 will return 1
    If lReturn = 1 Then
        MsgBox "There is 1 monitor in use.", vbInformation
    Else
        MsgBox "There are " & lReturn & " monitors in use.", vbInformation
    End If
End Sub

Private Sub cmdVirtualSize_Click()
    '===========================================
    'Display the position of the virtual desktop
    '===========================================
    With cMonitors
        MsgBox "Left: " & .DesktopLeft & vbCrLf & _
        "Top: " & .DesktopTop & vbCrLf & _
        "Width: " & .DesktopWidth & vbCrLf & _
        "Height: " & .DesktopHeight, vbInformation
    End With
End Sub

Private Sub cmdMonFromPoint_Click()
    '=======================================
    'Get the monitor that the x and y points
    'are in. (txtX.Text and txtY.Text)
    '=======================================
    Dim lReturn As Long
    
    'Select wich type of action is preferred
    'if the X/Y point in not on any monitor
    Select Case True
        Case optDefNone.Value
            lReturn = cMonitors.GetMonitorFromXYPoint(Val(txtX.Text), Val(txtY.Text), MONITOR_DEFAULTTONULL)
        Case optDefPri
            lReturn = cMonitors.GetMonitorFromXYPoint(Val(txtX.Text), Val(txtY.Text), MONITOR_DEFAULTTOPRIMARY)
        Case optDefNear
            lReturn = cMonitors.GetMonitorFromXYPoint(Val(txtX.Text), Val(txtY.Text), MONITOR_DEFAULTTONEAREST)
    End Select
    
    'Display the result
    Select Case lReturn
        Case -1
            MsgBox "Non-Multimonitor OS, only one monitor, and it does not have a handle.", vbInformation
        Case 0
            MsgBox "There is no monitor at those coordinates.", vbInformation
        Case Else
            MsgBox "Monitor Handle: " & lReturn & " is at those coordinates.", vbInformation
    End Select
End Sub

Private Sub cmdRefresh_Click()
    RefreshMonitors
End Sub

Private Sub RefreshMonitors()
    '==========================================================
    'Refreshes the monitors collection and the listbox contents
    '==========================================================
    
    cMonitors.Refresh
    lstMonitors.Clear
    
    'Iterate through all the monitors, add their handle to the listbox
    For Each cMonitor In cMonitors.Monitors
        lstMonitors.AddItem cMonitor.Handle
    Next
End Sub

Private Sub cmdWhatMon_Click()
    '========================================
    'Display the left, right, top, and bottom
    'of the current monitor
    '========================================
    Dim lReturn As Long
    Dim lMonitor As Long

    cMonitors.Refresh
    lMonitor = cMonitors.GetMonitorFromWindow(Me.hwnd, MONITOR_DEFAULTTONULL)
    
    If lMonitor < 1 Then
        'Monitor not found, default to the screen
        Set cMonitor = cMonitors.Monitors.Item(1)
    Else
        'Get the reference to the monitor
        Set cMonitor = cMonitors.Monitors.Item(CStr(lMonitor))
    End If
    With cMonitor
        MsgBox "Left: " & .Left & vbCrLf & _
        "Top: " & .Top & vbCrLf & _
        "Right: " & .Right & vbCrLf & _
        "Bottom: " & .Bottom & vbCrLf & _
        "Width: " & .Width & vbCrLf & _
        "Height: " & .Height, vbInformation
    End With
End Sub


Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    '==================
    'Display Popup menu
    '==================
    
    'Mouse Click on form
    'In VB5, the popup menu will always appear on the primary monitor
    'VB6 works properly
    PopupMenu mnuTest
End Sub

Private Sub lstMonitors_DblClick()
    '=============================================
    'Displays the monitor information when monitor
    'handle is double-clicked in the listbox
    '=============================================
    Dim lReturn As Long
    Set cMonitor = New clsMonitor
    
    'iterate through the monitors until we match the handle,
    'then display the information
    For Each cMonitor In cMonitors.Monitors
        With cMonitor
            If .Handle = lstMonitors.List(lstMonitors.ListIndex) Then
                MsgBox "Left: " & .Left & vbCrLf & _
                "Top: " & .Top & vbCrLf & _
                "Right: " & .Right & vbCrLf & _
                "Bottom: " & .Bottom & vbCrLf & _
                "Width: " & .Width & vbCrLf & _
                "Height: " & .Height, vbInformation
                Exit Sub
            End If
        End With
    Next
End Sub


